%ifndef ANMMACRO_INC
%define ANMMACRO_INC
;
%define ANMRESOLVE(=x) x
;
%assign numanimlists 0
%macro startlist 0
  %assign numanimlists numanimlists + 1
  %assign animlistsize%[numanimlists] 0
%endmacro
;
%macro addlistbytes 1-*
  %ifdef animlistdata%[numanimlists]
    %xdefine animlistdata%[numanimlists] animlistdata%[numanimlists], %{1:-1}
  %else
    %xdefine animlistdata%[numanimlists] %{1:-1}
  %endif
  %assign animlistsize%[numanimlists] animlistsize%[numanimlists] + %0
%endmacro
;
%assign numrenderops 0
%assign lastrendreoplookup 0
;
; {bytes}, key values
%macro addrenderops 2-*
  %xdefine renderopkeysuffix %2
  %rep %0 - 2
    %rotate 1
    %ifstr %2
      %deftok renderkeytemp, %2
      %xdefine renderopkeysuffix renderopkeysuffix %+ _ %+ renderkeytemp
    %eliftoken %2
      %xdefine renderopkeysuffix renderopkeysuffix %+ _ %+ %2
    %else
      %xdefine renderopkeysuffix renderopkeysuffix %+ _ %+ ANMRESOLVE(%2)
    %endif
  %endrep
  %rotate 2
  %ifdef renderopkey%[renderopkeysuffix]
    %assign lastrendreoplookup renderopkey%[renderopkeysuffix]
  %else
    %assign numrenderops numrenderops + 1
    %xdefine renderopkey%[renderopkeysuffix] numrenderops
    %xdefine renderopdata_%[numrenderops] %1
    %assign lastrendreoplookup numrenderops
  %endif
%endmacro
;
%macro addrenderparams 11
  addrenderops {(%1) | (%3), %4, (%5) & 0xff, (%5) >> 8 & 0xff, %6, (%7) & 0xff, (%7) >> 8 & 0xff, %8, (%9) & 0xff, (%9) >> 8 & 0xff, (%10) >> 8 & 0xff, (%10) & 0xff, (%11) >> 8 & 0xff, (%11) & 0xff, 33-14 dup (00h)}, %2, %{3:11}
%endmacro
;
%macro writeanimlistofstable 0
  %assign tempanimlistidx 0
  %assign tempanimlistofs (numanimlists * 2 + 1 + numrenderops * 33)
  db numanimlists
  %rep numanimlists
    %assign tempanimlistidx tempanimlistidx + 1
    dw tempanimlistofs
    %assign tempanimlistofs tempanimlistofs + animlistsize%[tempanimlistidx]
  %endrep
%endmacro
;
%macro writerenderopsdata 0
  %assign temprenderopidx 0
  %rep numrenderops
    %assign temprenderopidx temprenderopidx + 1
    db renderopdata_%[temprenderopidx]
  %endrep
%endmacro
;
%macro writeanimlistdata 0
  %assign tempanimlistidx 0
  %rep numanimlists
    %assign tempanimlistidx tempanimlistidx + 1
    %ifdef animlistdata%[tempanimlistidx]
      db animlistdata%[tempanimlistidx]
    %endif
  %endrep
%endmacro
;
; render ops
;
%define SRCDISPLAY 0
%define SRCBUFFER 2
%define DSTDISPLAY 0
%define DSTBUFFER 1
;
; bufferindexflags, srcminbytex, srcminy, srcmaxbytex, srcmaxy, dstbytex, dsty, unknown1, unknown2
%macro copyrect 9
  addrenderparams 10h, prefcopyrect, %{1:9}
  addlistbytes 14h + (lastrendreoplookup - 1)
%endmacro
; bufferindexflags, srcminbytex, srcminy, srcmaxbytex, srcmaxy, dstbytex, dsty
%macro maskrect 9
  addrenderparams 20h, prefmaskrect, %{1:9}
  addlistbytes 14h + (lastrendreoplookup - 1)
%endmacro
; bufferindexflags, srcminbytex, srcminy, srcmaxbytex, srcmaxy, dstbytex, dsty
%macro swaprect 9
  addrenderparams 30h, prefswaprect, %{1:9}
  addlistbytes 14h + (lastrendreoplookup - 1)
%endmacro
;
%macro setpaletteentry 2
  addrenderops {40h | (%1), (%2) & 0xff, (%2) >> 8 & 0xff, 33 - 3 dup (00h)}, prefsetpaletteentry, %{1:2}
  addlistbytes 14h + (lastrendreoplookup - 1)
%endmacro
; bufferindexflags, srcminbytex, srcminy, srcmaxbytex, srcmaxy, dstbytex, dsty
%macro unknownrect 9
  addrenderparams 50h, prefunknownrect, %{1:9}
  addlistbytes 14h + (lastrendreoplookup - 1)
%endmacro
; bufferindexflags, srcminbytex, srcminy, srcmaxbytex, srcmaxy, dstbytex, dsty
%macro clearrect 9
  addrenderparams 60h, prefclearrect, %{1:9}
  addlistbytes 14h + (lastrendreoplookup - 1)
%endmacro
;
%macro rendernop 0
  addrenderops {70h, 33 - 1 dup (00h)}, prefrendernop
  addlistbytes 14h + (lastrendreoplookup - 1)
%endmacro
;
%macro setpalette 16
  %xdefine temppalbytes 80h
  %rep 16
    %xdefine temppalbytes temppalbytes, ((%1) & 0xff), ((%1) >> 8 & 0xff)
    %rotate 1
  %endrep
  %rotate 1
  addrenderops {%[temppalbytes]}, prefrendernop, %{1:16}
  addlistbytes 14h + (lastrendreoplookup - 1)
%endmacro
;
; anim list ops
;
%macro endlist 0
  addlistbytes 0ffh
%endmacro

%macro nop 0
  addlistbytes 00h
%endmacro
;
%macro stopifreq 0
  addlistbytes 01h
%endmacro
; u8 ticks
%macro wait 1
  addlistbytes 02h, %1
%endmacro
;
%macro loop 0
  addlistbytes 03h
%endmacro
;
%macro end 0
  addlistbytes 04h
%endmacro
; u8 times
%macro rep1 1
  addlistbytes 05h, %1
%endmacro
;
%macro endrep1 0
  addlistbytes 06h
%endmacro
; u8 times
%macro rep2 1
  addlistbytes 07h, %1
%endmacro
;
%macro endrep2 0
  addlistbytes 08h
%endmacro
;
org 0
cpu 186
;
%endif