ORG 3e75h
CPU 186

%define data_0000239b 239bh
%define data_000023ab 23abh
%define data_textboxminbytex  1b30h
%define data_textcurrentbyteposx 1b2ch
%define data_textboxmaxbytex 1b34h
%define data_00001b74 1b74h
%define data_textboxminy 1b32h
%define data_textcurrentposy 1b2eh 
%define data_textboxmaxy 1b36h
%define func_cleartextbox 2698h

; advance text position
; parameter dh has low nibble that specifies the size of the character glyph
; returns byte x position in dx, y position in cx
func_0000245d:
  push ax
  push bx
  push dx
  push si
  push di
  and dx, 0f00h
  shr dx, byte 07h
  mov si, data_0000239b
  add si, dx ; low nibble of dh * 2
  mov si, word [si] ; character width
  mov di, data_000023ab
  add di, dx
  mov di, word [di] ; character height
  mov bx, word [data_textboxminbytex] ; first byte x text position
  add bx, word [data_textcurrentbyteposx] ; byte x text offset
  mov ax, bx ; x returned is value before adjustment
  add ax, si
  dec ax
  cmp ax, word [data_textboxmaxbytex] ; max y
  jbe label_0000249c ; next line down if current x + width - 1 (last byte x that would be rendered) > maxy position, since it would escape bounds
    mov bx, word [data_textboxminbytex] ; return leftmost x instead
    mov word [data_textcurrentbyteposx], 0000h
    add di, word [data_00001b74] ; vertical line spacing
    add word [data_textcurrentposy], di ; advance y by character height and row separation
  label_0000249c:
  add word [data_textcurrentbyteposx], si ; next bytex pos
  mov cx, word [data_textboxminy]
  add cx, word [data_textcurrentposy] ; y value to return
  mov ax, cx
  add ax, di
  dec ax
  cmp ax, word [data_textboxmaxy] ; max y pos
  jbe label_000024d2 ; if lowest x would exceed text box bounds, wrap to top
    mov cx, word [data_textboxminy]
    mov word [data_textcurrentposy], 0000h ; reset height to top
    push bp
    sub sp, byte 02h
    mov bp, sp
    mov byte [byte bp+00h], 00h
    push es
    pusha
    call near func_cleartextbox ; clears a text rectangle
    popa
    pop es
    add sp, byte 02h
    pop bp
  label_000024d2:
  mov ax, bx
  pop di
  pop si
  pop dx
  pop bx
  mov bl, al
  pop ax
  retn
