#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char nextline(FILE* file, char* buffer, unsigned int buffersize, int* buffered, int* lineofs, int* lineend, char* state) {
  int nstate = *state;
  char eos = 0;
  int blen = *buffered;
  int ofs = *lineend;
  if ((nstate & 1)) {
    if (ofs < blen) {
      ofs += (buffer[ofs] == '\n');
    } else {
      ofs = 0;
      blen = fread(buffer, 1, buffersize, file);
      *buffered = blen;
      if (ofs < blen) {
        ofs += (buffer[ofs] == '\n');
      }
    }
  }
  nstate = 0;
  int end = ofs;
  char foundend = 0;
  do {
    if (end == blen) {
      if ((unsigned int)blen == buffersize) {
        if (ofs > 0) {
          memmove(buffer, buffer + ofs, end - ofs);
          end -= ofs;
          blen -= ofs;
          ofs = 0;
        }
        if ((unsigned int)blen < buffersize) {
          blen += fread(buffer + blen, 1, buffersize - blen, file);
          *buffered = blen;
        }
      } else {
        eos = 1;
      }
    }
    foundend = 1;
    while (end < blen && !(foundend = ((buffer[end] == '\n') | (buffer[end] == '\r')))) {
      ++end;
    }
    if (end < blen) {
      nstate = (buffer[end] == '\r');
      ++end;
    }
  } while (!foundend);
  *state = nstate;
  *lineofs = ofs;
  *lineend = end;
  return !eos;
}

void setu16l(char* buffer, int value) {
  buffer[0] = (char)(value & 0xff);
  buffer[1] = (char)(value >> 8 & 0xff);
}

void setu32l(char* buffer, int value) {
  buffer[0] = (char)(value & 0xff);
  buffer[1] = (char)(value >> 8 & 0xff);
  buffer[2] = (char)(value >> 16 & 0xff);
  buffer[3] = (char)(value >> 24 & 0xff);
}

// in listfile, out diskfile
int main(int argc, char const** argv) {
  char success = 0;
  if (argc == 3) {
    FILE* listfile = fopen(argv[1], "rb");
    if (listfile != NULL) {
      success = 1;
      int const readbuffersize = 16384;
      char readbuffer[readbuffersize];
      int const writebuffersize = 16384;
      char writebuffer[writebuffersize];
      int numfiles = 0;
      int filepaths[16384];
      int filesizes[8192];

      int valuebufferlen = 0;
      int valuebuffercap = 16384;
      int writebuffered = 0;
      int readbuffered = 0;
      int lineofs = 0;
      int lineend = 0;
      char state = 0;
      char hasmore = 1;
      char* text = malloc(valuebuffercap);
      if (text != NULL) {
        readbuffered = fread(readbuffer, 1, readbuffersize, listfile);
        do {
          hasmore = nextline(listfile, readbuffer, readbuffersize, &readbuffered, &lineofs, &lineend, &state);
          int len2 = lineend - lineofs;
          int eofs = lineend;
          if (len2 >= 1 && ((readbuffer[lineend - 1] == '\r') | (readbuffer[lineend - 1] == '\n'))) {
            --eofs;
          }
          if (len2 >= 2 && ((readbuffer[lineend - 2] == '\r'))) {
            --eofs;
          }
          int sofs = lineofs;
          while (sofs < eofs && readbuffer[sofs] == ' ') {
            ++sofs;
          }
          int ofs1 = sofs;
          while (sofs < eofs && readbuffer[sofs] != ' ') {
            ++sofs;
          }
          int ofs2 = sofs;
          while (sofs < eofs && readbuffer[sofs] == ' ') {
            ++sofs;
          }
          int ofs3 = sofs;
          while (eofs > ofs3 && readbuffer[eofs - 1] ==' ') {
            --eofs;
          }
          if (ofs2 > ofs1 && eofs > ofs3) {
            if (numfiles < 8192) {
              int slen1 = ofs2 - ofs1;
              int slen2 = eofs - ofs3;
              int addlen = slen1 + 1 + slen2 + 1;
              if (valuebufferlen + addlen > valuebuffercap) {
                void* newptr = realloc(text, valuebuffercap * 2);
                if (newptr != NULL) {
                  text = newptr;
                  valuebuffercap *= 2;
                } else {
                  hasmore = 0;
                  success = 0;
                }
              }
              if (valuebufferlen + addlen <= valuebuffercap) {
                memcpy(text + valuebufferlen, readbuffer + ofs1, slen1);
                text[valuebufferlen + slen1]  = 0;
                memcpy(text + valuebufferlen + slen1 + 1, readbuffer + ofs3, slen2);
                text[valuebufferlen + slen1 + 1 + slen2]  = 0;
                filepaths[numfiles * 2] = valuebufferlen;
                filepaths[numfiles * 2 + 1] = valuebufferlen + slen1 + 1;
                FILE* testfile = fopen(text + filepaths[numfiles * 2 + 1], "rb");
                if (testfile != NULL) {
                  fclose(testfile);
                  ++numfiles;
                  valuebufferlen += addlen;
                } else {
                  printf("File does not exist so could not be added %s\n", text + filepaths[numfiles * 2 + 1]);
                  fflush(stdout);
                  success = 0;
                }
              }
            }
          }
        } while (hasmore);
        fclose(listfile);
        //
        if (success) {
          FILE* diskfile = fopen(argv[2], "wb");
          int offset = 2 + 19 * numfiles;
          {
            int numzeroes = offset;
            int rem = numzeroes < writebuffersize ? numzeroes : writebuffersize;
            memset(writebuffer, 0, rem);
            while (numzeroes > 0) {
              fwrite(writebuffer, 1, rem, diskfile);
              numzeroes -= rem;
              rem = numzeroes < writebuffersize ? numzeroes : writebuffersize;
            }
          }
          for (int i = 0; i < numfiles; ++i) {
            FILE* file = fopen(text + filepaths[i * 2 + 1], "rb");
            int fsize = 0;
            int rsize = 0;
            do {
              rsize = fread(writebuffer, 1, writebuffersize, file);
              if (rsize > 0) {
                fwrite(writebuffer, 1, rsize, diskfile);
              }
              fsize += rsize;
            } while (rsize == writebuffersize);
            fclose(file);
            filesizes[i] = fsize;
          }
          //
          fseek(diskfile, 0, SEEK_SET);
          writebuffered = 2;
          setu16l(writebuffer, numfiles);
          for (int i = 0; i < numfiles; ++i) {
            if (writebuffered + 19 > writebuffersize) {
              fwrite(writebuffer, 1, writebuffered, diskfile);
              writebuffered = 0;
            }
            int namelen = filepaths[i * 2 + 1] - filepaths[i * 2 + 0];
            namelen = namelen > 12 ? 12 : namelen;
            memcpy(writebuffer + writebuffered, text + filepaths[i * 2], namelen);
            memset(writebuffer + writebuffered + namelen, 0, 13 - namelen);
            setu16l(writebuffer + writebuffered + 13, filesizes[i]);
            setu32l(writebuffer + writebuffered + 15, offset);
            offset += filesizes[i];
            writebuffered += 19;
          }
          if (writebuffered > 0) {
            fwrite(writebuffer, 1, writebuffered, diskfile);
          }
          fclose(diskfile);
          free(text);
        }
      }
    }
  }
  return !success;
}